% .CALCULATING THE SIDE FORCE AT EVERY LAST DRILLING RUN IN A WELL
% SECTION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%clear all
T = xlsread('para');%read the xlsx file conyaing the sideforce parameters
%DS parameters
a=T(1,5);%average dry weight of DP (kg/m)
b=T(2,1);%length of HWDP
c=T(2,5);%average dry weight of HWDP (kg/m)
d=T(3,1);%length of DC
e=T(3,5);%average dry weight of DC (kg/m)
f=T(4,1);%length of PDM
g=T(4,5);%average dry weight of PDM (kg/m)
h=T(5,1);%length of PDC
i=T(5,5);%average dry weight of PDC (kg/m)
MW=1.3; % assumed mud weight
Dsteel=7.85;%density of steel
WOB=10;%assumed WOB (tons)
fr=0.2;%friction factor

%1. Estimation of SF and tensions at the BHA
wtd=b*c+d*e+f*g+h*i;%Average dry weight of the BHA
BF=1-(MW./Dsteel);%bouyance factor
wtt=BF*wtd./1000;%wet weight of the BHA
wdp=BF*500*a./1000; %weight of DP at every section
%Net=wtt./1000-WOB; %net weight on BHA in tons
%inclination and azimuth are estimated fom the plot of INC and AZI against
%measured depth at every 500 m from the BHA (starting 4444 m to 4562 m  )
inc1=14.57;
inc2=54.78;
azi1=63.62;
azi2=69.87;
Dogleg1=abs(acosd(cosd(inc1).*cosd(inc2)+sind(inc1).*sind(inc2)...
    *(cosd(azi2-azi1))));
%SF1=2*Net*(sind(Dogleg1./2));%side force at the BHA
SF1=wtt*sind((inc1+inc2)/2);
%Tension below BHA 
T1=0;%assuming that tension below the BHA=WOB
T2=wtt*cosd((inc1+inc2)/2)+fr*SF1;%tension at the top of BHA 
%2. Estimation of SF and tensions at the first subinterval 
%inclination and azimuth are estimated from 3944 m to 4444 m 
inc_1=14.57;
inc_2=54.64;
azi_1=63.62;
azi_2=70;
Dogleg2=abs(acosd(cosd(inc_1).*cosd(inc_2)+sind(inc_1).*sind(inc_2)...
    *(cosd(azi_2-azi_1))));
SF2=wdp*sind((inc_1+inc_2)/2);%side force above the BHA
T3=T2+fr*SF2+wdp*cosd((inc_1+inc_2)/2); % tension above the first subinterval

%3. Estimation of SF and tensions at the second subinterval 
%inclination and azimuth are estimated from 3444 m to 3944 m 
Inc_1=14.47;
Inc_2=81.94;
Azi_1=63.62;
Azi_2=68.17;
Dogleg3=abs(acosd(cosd(Inc_1).*cosd(Inc_2)+sind(Inc_1).*sind(Inc_2)...
    *(cosd(Azi_2-Azi_1))));
SF3=wdp*(sind(Inc_1+Inc_2)/2);%side force at the BHA
T4=T3+fr*SF3+BF*wdp*cosd((Inc_1+Inc_2)/2);%tension above  the second subinterval
%4. Estimation of SF and tensions at the third subinterval 
%inclination and azimuth are estimated from 2944 m to 3444 m 
Inc1=14.47;
Inc2=67.84;
Azi1=63.62;
Azi2=69.86;
Dogleg4=abs(acosd(cosd(Inc1).*cosd(Inc2)+sind(Inc1).*sind(Inc2)...
    *(cosd(Azi2-Azi1))));
SF4=wdp*(sind(Inc1+Inc2)./2);
T5=T4+fr*SF4+BF*wdp*cosd((Inc1+Inc2)./2);%tension above  the third  subinterval
%5. Estimation of SF and tensions at the forth subinterval 
%inclination and azimuth are estimated from 2444 m to 2944 m
In1=14.47;
In2=27.23;
Az1=63.62;
Az2=67.74;
Dogleg5=abs(acosd(cosd(In1).*cosd(In2)+sind(In1).*sind(In2)...
    *(cosd(Az2-Az1))));
SF5=wdp*(sind(In1+In2)/2);
T6=T5+fr*SF5+BF*wdp*cosd((In1+In2)/2);%tension above  the forth  subinterval

%6. Estimation of SF and tensions at the fifth subinterval 
%inclination and azimuth are estimated from 1944 m to 2444 m
In_1=14.47;
In_2=14.55;
Az_1=63.62;
Az_2=263.4;
Dogleg6=abs(acosd(cosd(In_1).*cosd(In_2)+sind(In_1).*sind(In_2)...
    *(cosd(Az_2-Az_1))));
SF6=wdp*sind((In_1+In_2)/2);
T7=T6+fr*SF6+BF*wdp*cosd((In_1+In_2)/2);%tension above  the fifth subinterval
%7. Estimation of SF and tensions at the sixth subinterval 
%inclination and azimuth are estimated from 1444 m to 1944 m
in_1=14.47;
in_2=28.53;
az_1=63.62;
az_2=263;
Dogleg7=abs(acosd(cosd(in_1).*cosd(in_2)+sind(in_1).*sind(in_2)...
    *(cosd(az_2-az_1))));
SF7=wdp*sind((in_1+in_2)/2);
T8=T7+fr*SF7+BF*wdp*cosd((in_1+in_2)/2);%tension above  the sixth subinterval

%COMBINING THE OBTAINED RESULTS
J=[SF1,SF2,SF3,SF4,SF5,SF6,SF7]';%Combining the estimated SF
N=[T2, T3,T4,T5,T6,T7,T8]'; %Combining the estimated tensions
D=[4562,4444,3944,3544,2944,2544,1944]';%Depth of subintervals
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%. REPORTING WHENEVER SF > threshold values 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SFNew=zeros(length(J),1);
for j=1:length(J)
if J(j)>1
    SFNew(j)=1;
else
   SFNew(j)=0;
end 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% : PLOTTING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1)
plot(N,D,'-.dk','MarkerEdgeColor','k','MarkerFaceColor','k');
% title('Computed side force and string tension for 15/9-F-11 wellbore');
grid on 
hold on 
plot(J,D,'-.sr','MarkerEdgeColor','r','MarkerFaceColor','r');
legend('String Tension','Computed Side force','location','best');
ylabel('Measured Depth [m]')
xlabel('Weight [Ton]')
set(gca,'ydir','reverse')
set(gca,'yLim',[1800 5000])
figure(2)
plot(SFNew,D,'-.ob','MarkerEdgeColor','b','MarkerFaceColor','b');
% title('Computed SF and indication of allowable SF limit for 15/9-F-11 wellbore');
hold on 
plot(J,D,'-.sr','MarkerEdgeColor','r','MarkerFaceColor','r');
legend('Indication of allowable Side force limit','Computed Side force','location','best');
ylabel('Measured Depth [m]')
xlabel('Weight [Ton]')
grid on
set(gca,'ydir','reverse')
set(gca,'yLim',[1800 5000])